/*
 * image.h
 *
 *  Created on: 25-02-2013
 *      Author: crm
 */

#pragma once

#include <gl/glee.h>
#include <gl/gl.h>
//#include <SDL/SDL.h>

#include "../refcounted.h"

namespace Engine
	{
	struct Image: public RefCounted
		{
		private:
			Image(const Image& i): RefCounted(*this), tex(i.tex), w(i.w), h(i.h) {}
			Image& operator=(const Image& i) {tex=i.tex; w=i.w; h=i.h; return *this;}

		public:
			Image(): tex(0u), /*srf(nullptr),*/ w(0), h(0) {}
			Image(GLuint tex, int w, int h): RefCounted(), tex(tex), /*srf(nullptr),*/ w(w), h(h) {}
			virtual ~Image() {}

			GLuint tex;
			//SDL_Surface *srf;

			int w, h;
		};
	}
