/*
 * button.h
 *
 *  Created on: 04-04-2013
 *      Author: crm
 */

#pragma once

#include <string>

#include "../render/spriteptr.h"

#include "base.h"

namespace Engine
	{
	namespace UI
		{
		class Button: public Base
			{
			protected:
				SpritePtr spr;

				unsigned pressed;

			public:
				//Button();
				//virtual ~Button();

				virtual void init(Rect r, const std::string& name);
				virtual void update(float dt);
				virtual void print();

				virtual void click(int x, int y);
			};
		}
	}
