/*
 * CounterAnimated.h
 *
 *  Created on: 26-03-2013
 *      Author: crm
 */

#pragma once

#include <string>

#include "counter.h"
#include "../render/spriteptr.h"

namespace Engine
	{
	namespace UI
		{
		class CounterAnimated: public Counter
			{
			protected:
				SpritePtr spr;

			public:
				CounterAnimated();
				virtual ~CounterAnimated();

				virtual void init(const std::string& name, float min, float max, float val);
				virtual void update(float dt);
				virtual void print(float x, float y);
				virtual void clear();
			};
		}
	}
